//**************************************************************************
// ﾌｧｲﾙ内容     「aqm1248.ino」I2Cグラフィック液晶AQM1248の制御（文字）
// Copyright    ジャパンマイコンカーラリー実行委員会
// ライセンス   This software is released under the MIT License.
//              http://opensource.org/licenses/mit-license.php
//**************************************************************************

// インクルード宣言
#define SPI SPI1              // RMC-RA4M1 rev.1.0bはSPIではなくSPI1を使用
#include <MGLCD.h>            // 出典；しなぷすのハード製作記　https://synapse.kyoto/lib/MGLCD/page001.html
#include <MGLCD_SPI.h>
#include <SPI.h>

// グローバル変数の宣言
MGLCD_AQM1248A_SPI MGLCD( MGLCD_SpiPin2(10, 9), 100000L );  // (10=CSピン,9=RSピン), MAX_FREQの設定

void setup()
{
  // LCDの初期化
  while( MGLCD.Reset() );         // CS=10pin  RS=9pin  SCLK=13pin  SDI=11pin
  if( strlen("ｱ") != 1 ) MGLCD.SetCodeMode( MGLCD_CODE_UTF8 );  // 半角カナ表示の有効化
  MGLCD.SetVolumeResistor( 28 );  // コントラストの調整 0～63
  MGLCD.ClearScreen();

  MGLCD.Locate( 0, 0 );                   // 左から0番目 , 上から0番目
  MGLCD.print( "000000000011111111112" ); // 横21文字
  MGLCD.print( "012345678901234567890" );

  for( char i = ':'; i<= '}'; i++ ) {
    MGLCD.print( i );
  }
  MGLCD.print( "ｱｲｳｴｵｶｷｸｹｺｬｭｮﾜﾝｦ" );       // 半角カタカナ表示
}

void loop()
{
  // 特に何もしない
}