//**************************************************************************
// ﾌｧｲﾙ内容     「microsd.ino」microSD ファイル書き込み、読み込み
// Copyright    ジャパンマイコンカーラリー実行委員会
// ライセンス   This software is released under the MIT License.
//              http://opensource.org/licenses/mit-license.php
//**************************************************************************

// インクルード
#include <SPI.h>
#include <SD.h>

// グローバル変数宣言
File microSD;  // microSDのファイルアクセス用

void setup() {
  Serial.begin( 9600 );

  while( !Serial ) {
    // シリアル接続されるまで待つ
  }

  Serial.println( "" );
  Serial.print( "1 microSDを確認中です... " );


  if( !SD.begin( CS ) ) {     // SDカードのチップセレクトライン それ以外はpins_arduino.hで定義
    Serial.println( "microSDが認識されません!" );
    while( 1 );  // 終了
  } else {
    // microSD認識OK!
    Serial.println( "microSDを認識しました。" );
  }

  // microSDへ書き込み
  microSD = SD.open( "test.txt", FILE_WRITE );
  if( microSD != 0 ) {  // エラーがないなら
    microSD.println( "テストです。" );  // ファイルの末尾に追加で書き込む
    microSD.close();
    Serial.println( "2 microSDに書き込みができました。" );
  } else {
    Serial.println( "2 ファイル書き込み(FILE_WRITE)ができませんでした。" );
    while( 1 );
  }

  // microSDから読み込み
  microSD = SD.open( "test.txt", FILE_READ );
  if( microSD != 0 ) {  // エラーがないなら
    Serial.println( "3 ファイルの内容を表示します。" );
    Serial.println( "------------------------------ ここから" );
    while ( microSD.available() ) {     // ファイルにデータがあれば
      Serial.write( microSD.read() );   // データを読み込んでシリアルに出力
    }
    microSD.close();
  } else {
    Serial.println( "3 ファイル読み込み(FILE_READ)ができませんでした。" );
    while( 1 );
  }

  Serial.println( "------------------------------ ここまで" );
  Serial.println( "4 プログラムを終了します。" );
}

void loop() {
  // 何もしない
}